<?php

define( '_JEXEC', 1 );
define('JPATH_BASE', dirname(__FILE__) );
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVMPaymentZpayment extends vmPSPlugin {

    // instance of class
    public static $_this = false;

    function __construct(& $subject, $config) {

	parent::__construct($subject, $config);

	$this->_loggable = true;
	$this->tableFields = array_keys($this->getTableSQLFields());

	$varsToPush = array(
	    'eshop_id' => array('', 'int'),
		'merch_key' => array('', 'int'),
		'init_pass' => array('', 'int'),
	    'Zpayment_currency' => array(0, 'int'),
	    'debug' => array(0, 'int'),
	    'status_pending' => array('', 'char'),
	    'status_success' => array('', 'char'),
	    'status_canceled' => array('', 'char'),
	    'countries' => array(0, 'char'),
	    'cost_per_transaction' => array(0, 'int'),
	    'cost_percent_total' => array(0, 'int'),
	    'tax_id' => array(0, 'int')
	);

	$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);


    }

    protected function getVmPluginCreateTableSQL() {
	return $this->createTableSQL('Payment Zpayment Table');
    }

    function getTableSQLFields() {

	$SQLfields = array(
	    'id' => ' tinyint(1) unsigned NOT NULL AUTO_INCREMENT ',
	    'virtuemart_order_id' => ' int(11) UNSIGNED DEFAULT NULL',
	    'order_number' => ' char(32) DEFAULT NULL',
	    'virtuemart_paymentmethod_id' => ' mediumint(1) UNSIGNED DEFAULT NULL',
	    'payment_name' => ' char(255) NOT NULL DEFAULT \'\' ',
	    'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    'payment_currency' => 'char(3) ',
	    'cost_per_transaction' => ' decimal(10,2) DEFAULT NULL ',
	    'cost_percent_total' => ' decimal(10,2) DEFAULT NULL ',
	    'tax_id' => ' smallint(1) DEFAULT NULL',
	    'Zpayment_custom' => ' varchar(255)  ',
	    'Zpayment_response_mc_gross' => ' decimal(10,2) DEFAULT NULL ',
	    'Zpayment_response_mc_currency' => ' char(10) DEFAULT NULL',
	    'Zpayment_response_invoice' => ' char(32) DEFAULT NULL',
	    'Zpayment_response_protection_eligibility' => ' char(128) DEFAULT NULL',
	    'Zpayment_response_payer_id' => ' char(13) DEFAULT NULL',
	    'Zpayment_response_tax' => ' decimal(10,2) DEFAULT NULL ',
	    'Zpayment_response_payment_date' => ' char(28) DEFAULT NULL',
	    'Zpayment_response_payment_status' => ' char(50) DEFAULT NULL',
	    'Zpayment_response_mc_fee' => ' decimal(10,2) DEFAULT NULL ',
	    'Zpayment_response_payer_email' => ' char(128) DEFAULT NULL',
	    'Zpayment_response_last_name' => ' char(64) DEFAULT NULL',
	    'Zpayment_response_first_name' => ' char(64) DEFAULT NULL',
	    'Zpayment_response_business' => '  char(128) DEFAULT NULL',
	    'Zpayment_response_receiver_email' => '  char(128) DEFAULT NULL',
	    'Zpayment_response_transaction_subject' => ' char(128) DEFAULT NULL',
	    'Zpayment_response_residence_country' => ' char(2) DEFAULT NULL',
	    'Zpaymentresponse_raw' => ' char DEFAULT NULL'
	);
	return $SQLfields;
    }

  function plgVmConfirmedOrder($cart, $order) {

	if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
	    return null;
	}
	if (!$this->selectedThisElement($method->payment_element)) {
	    return false;
	}
	$session = JFactory::getSession();
	$return_context = $session->getId();
	$this->_debug = $method->debug;
	$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
	if (!class_exists('VirtueMartModelCurrency'))
	    require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');

	$address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

	$vendorModel = new VirtueMartModelVendor();
	$vendorModel->setId(1);
	$vendor = $vendorModel->getVendor();
	$totalInPaymentCurrency =  number_format($order['details']['BT']->order_total, 2, '.', '');
    $eshop_id = $method->eshop_id; 
    $init_pass = $method->init_pass;
    $josvirtuemart_order_id=$order['details']['BT']->virtuemart_order_id; 
    $domain	= str_replace("www.","",$_SERVER['SERVER_NAME']); 
    $order_id=$order['details']['BT']->order_number;
    $serviceName = 'Покупка товара в интернет магазине  '.$domain	.' Номер вашего заказа:'.$order_id;
    $hash = md5($eshop_id.$order_id.$totalInPaymentCurrency.$init_pass);
	$post_variables = Array(
		"LMI_PAYEE_PURSE" => $eshop_id,
		"LMI_PAYMENT_NO" =>$order_id,
		"LMI_PAYMENT_AMOUNT" =>$totalInPaymentCurrency,
		"LMI_PAYMENT_DESC" =>$serviceName ,
	    "CLIENT_EMAIL" => $address->email,
	    "ZP_SIGN" => $hash
	    );
    $url = 'https://z-payment.com/merchant.php'; // адрес отправки
 

	$html = '<form action="' . "" . $url . '" method="get" name="vm_zpayment_form">';
	$html.= '<input type="image" name="submit" src="https://z-payment.com/images/logo.gif" alt="z-payment.com" />';
	foreach ($post_variables as $name => $value) {
	    $html.= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
	}
	$html.= '</form>';
	$html.= ' <script type="text/javascript">';
	$html.= ' document.vm_zpayment_form.submit();';
	$html.= ' </script>';

		//We delete the old stuff
		$cart->emptyCart ();
		JRequest::setVar ('html', $html);



    }



    function plgVmOnPaymentResponseReceived(  &$html) {

// the payment itself should send the parameter needed.
	$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);

	$vendorId = 0;
	if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
	    return null; // Another method was selected, do nothing
	}
	if (!$this->selectedThisElement($method->payment_element)) {
	    return false;
	}

	$payment_data = JRequest::get('post');
	vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
	$order_number = $payment_data['orderId'];
	$return_context = $payment_data['userField_1'];
	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
	$payment_name = $this->renderPluginName($method);


		    if ($virtuemart_order_id) {
			if (!class_exists('VirtueMartCart'))
			    require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
			$cart = VirtueMartCart::getCart();
			if (!class_exists('VirtueMartModelOrders'))
			    require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
			$order = new VirtueMartModelOrders();
			$orderitems = $order->getOrder($virtuemart_order_id);
			$cart->sentOrderConfirmedEmail($orderitems);

			$cart->emptyCart();
		    }

	return true;
    }

    function plgVmOnUserPaymentCancel() {

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

	$order_number = JRequest::getVar('on');
	if (!$order_number)
	    return false;
	$db = JFactory::getDBO();
	$query = 'SELECT ' . $this->_tablename . '.`virtuemart_order_id` FROM ' . $this->_tablename. " WHERE  `order_number`= '" . $order_number . "'";

	$db->setQuery($query);
	$virtuemart_order_id = $db->loadResult();

	if (!$virtuemart_order_id) {
	    return null;
	}
	$this->handlePaymentUserCancel($virtuemart_order_id);

	return true;
    }

  
   function _debug($method) {
	return $method->debug;
    }
   



    
    

  

    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
	if (preg_match('/%$/', $method->cost_percent_total)) {
	    $cost_percent_total = substr($method->cost_percent_total, 0, -1);
	} else {
	    $cost_percent_total = $method->cost_percent_total;
	}
	return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    /**
     * Проверка, платежных условий для данного способа оплаты
     *
     */
    protected function checkConditions($cart, $method, $cart_prices) {


	$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

	$amount = $cart_prices['salesPrice'];
	$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
		OR
		($method->min_amount <= $amount AND ($method->max_amount == 0) ));

	$countries = array();
	if (!empty($method->countries)) {
	    if (!is_array($method->countries)) {
		$countries[0] = $method->countries;
	    } else {
		$countries = $method->countries;
	    }
	}
	// probably did not gave his BT:ST address
	if (!is_array($address)) {
	    $address = array();
	    $address['virtuemart_country_id'] = 0;
	}

	if (!isset($address['virtuemart_country_id']))
	    $address['virtuemart_country_id'] = 0;
	if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
	    if ($amount_cond) {
		return true;
	    }
	}

	return false;
    }

     function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

	return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
	return $this->OnSelectCheck($cart);
    }

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
	return $this->displayListFE($cart, $selected, $htmlIn);
    }

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
	return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
	return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	  $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

     function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	return $this->onShowOrderPrint($order_number, $method_id);
    }

     function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
	return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
	return $this->setOnTablePluginParams($name, $id, $table);
    }

}

// No closing tag
